---
title: InputEvent
slug: Web/API/InputEvent
tags:
  - API
  - DOM
  - DOM Events
  - Input
  - Interface
  - Reference
  - events
---
<div>{{APIRef("DOM Events")}}</div>

<p>The <strong><code>InputEvent</code></strong> interface represents an event notifying the user of editable content changes.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{DOMxRef("InputEvent.InputEvent", "InputEvent()")}}</dt>
 <dd>Creates an <code>InputEvent</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>This interface <em>inherits properties from its parents, {{DOMxRef("UIEvent")}} and {{DOMxRef("Event")}}.</em></em></p>

<dl>
 <dt>{{DOMxRef("InputEvent.data")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DOMString")}} with the inserted characters. This may be an empty string if the change doesn't insert text (such as when deleting characters, for example).</dd>
 <dt>{{DOMxRef("InputEvent.dataTransfer")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{DOMxRef("DataTransfer")}} object containing information about richtext or plaintext data being added to or removed from editable content.</dd>
 <dt>{{DOMxRef("InputEvent.inputType")}}{{ReadOnlyInline}}</dt>
 <dd>Returns the type of change for editable content such as, for example, inserting, deleting, or formatting text. See the property page for a complete list of input types.</dd>
 <dt>{{DOMxRef("InputEvent.isComposing")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{JSxRef("Boolean")}} value indicating if the event is fired after {{event("compositionstart")}} and before {{event("compositionend")}}.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface <em>inherits methods from its parents, {{DOMxRef("UIEvent")}} and {{DOMxRef("Event")}}.</em></em></p>

<dl>
 <dt>{{DOMxRef('InputEvent.getTargetRanges()')}}</dt>
 <dd>Returns an array of static ranges that will be affected by a change to the DOM if the input event is not canceled.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table" style="height: 49px; width: 1000px;">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('InputEvents2', '#interface-InputEvent', 'InputEvent')}}</td>
   <td>{{Spec2('InputEvents2')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('UI Events', '#interface-inputevent', 'InputEvent')}}</td>
   <td>{{Spec2('UI Events')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.InputEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/HTMLElement/beforeinput_event"><code>beforeinput</code> event</a></li>
 <li><a href="/en-US/docs/Web/API/InputEvent/input_event"><code>input</code> event</a></li>
</ul>
